Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision 56699f009a608ecff3a247a08b3d0105a5e17153)
+++ protocols/yahoo/libyahoo2.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
@@ -3,4 +3,6 @@
  *
  * Some code copyright (C) 2002-2004, Philip S Tellis <philip.tellis AT gmx.net>
+ * YMSG16 code copyright (C) 2009, 
+ * 		Siddhesh Poyarekar <siddhesh dot poyarekar at gmail dot com>
  *
  * Yahoo Search copyright (C) 2003, Konstantin Klyagin <konst AT konst.org.ua>
@@ -27,4 +29,6 @@
  *     <hiro-y@kcn.ne.jp>
  *
+ * YMSG16 authentication code based mostly on write-up at:
+ * 	http://www.carbonize.co.uk/ymsg16.html
  *
  * This program is free software; you can redistribute it and/or modify
@@ -92,7 +96,7 @@
 
 #ifdef USE_STRUCT_CALLBACKS
-struct yahoo_callbacks *yc=NULL;
-
-void yahoo_register_callbacks(struct yahoo_callbacks * tyc)
+struct yahoo_callbacks *yc = NULL;
+
+void yahoo_register_callbacks(struct yahoo_callbacks *tyc)
 {
 	yc = tyc;
@@ -106,5 +110,5 @@
 static int yahoo_send_data(int fd, void *data, int len);
 
-int yahoo_log_message(char * fmt, ...)
+int yahoo_log_message(char *fmt, ...)
 {
 	char out[1024];
@@ -113,10 +117,10 @@
 	vsnprintf(out, sizeof(out), fmt, ap);
 	va_end(ap);
-	return YAHOO_CALLBACK(ext_yahoo_log)("%s", out);
-}
-
-int yahoo_connect(char * host, int port)
-{
-	return YAHOO_CALLBACK(ext_yahoo_connect)(host, port);
+	return YAHOO_CALLBACK(ext_yahoo_log) ("%s", out);
+}
+
+int yahoo_connect(char *host, int port)
+{
+	return YAHOO_CALLBACK(ext_yahoo_connect) (host, port);
 }
 
@@ -138,12 +142,12 @@
 static char pager_host[] = "scs.msg.yahoo.com"; 
 static int pager_port = 5050;
-static int fallback_ports[]={23, 25, 80, 20, 119, 8001, 8002, 5050, 0};
-static char filetransfer_host[]="filetransfer.msg.yahoo.com";
-static int filetransfer_port=80;
-static char webcam_host[]="webcam.yahoo.com";
-static int webcam_port=5100;
-static char webcam_description[]="";
-static char local_host[]="";
-static int conn_type=Y_WCM_DSL;
+static int fallback_ports[] = { 23, 25, 80, 20, 119, 8001, 8002, 5050, 0 };
+static char filetransfer_host[] = "filetransfer.msg.yahoo.com";
+static int filetransfer_port = 80;
+static char webcam_host[] = "webcam.yahoo.com";
+static int webcam_port = 5100;
+static char webcam_description[] = "";
+static char local_host[] = "";
+static int conn_type = Y_WCM_DSL;
 
 static char profile_url[] = "http://profiles.yahoo.com/";
@@ -215,16 +219,16 @@
 	YAHOO_SERVICE_PICTURE_UPDATE = 0xc1,
 	YAHOO_SERVICE_PICTURE_UPLOAD = 0xc2,
-	YAHOO_SERVICE_Y6_VISIBILITY=0xc5,
-	YAHOO_SERVICE_Y6_STATUS_UPDATE=0xc6,
-	YAHOO_PHOTOSHARE_INIT=0xd2,	
-	YAHOO_SERVICE_CONTACT_YMSG13=0xd6,
-	YAHOO_PHOTOSHARE_PREV=0xd7,
-	YAHOO_PHOTOSHARE_KEY=0xd8,
-	YAHOO_PHOTOSHARE_TRANS=0xda,
-	YAHOO_FILE_TRANSFER_INIT_YMSG13=0xdc,
-	YAHOO_FILE_TRANSFER_GET_YMSG13=0xdd,
-	YAHOO_FILE_TRANSFER_PUT_YMSG13=0xde,
-	YAHOO_SERVICE_YMSG15_STATUS=0xf0,
-	YAHOO_SERVICE_YMSG15_BUDDY_LIST=0xf1,
+	YAHOO_SERVICE_Y6_VISIBILITY = 0xc5,
+	YAHOO_SERVICE_Y6_STATUS_UPDATE = 0xc6,
+	YAHOO_PHOTOSHARE_INIT = 0xd2,	
+	YAHOO_SERVICE_CONTACT_YMSG13 = 0xd6,
+	YAHOO_PHOTOSHARE_PREV = 0xd7,
+	YAHOO_PHOTOSHARE_KEY = 0xd8,
+	YAHOO_PHOTOSHARE_TRANS = 0xda,
+	YAHOO_FILE_TRANSFER_INIT_YMSG13 = 0xdc,
+	YAHOO_FILE_TRANSFER_GET_YMSG13 = 0xdd,
+	YAHOO_FILE_TRANSFER_PUT_YMSG13 = 0xde,
+	YAHOO_SERVICE_YMSG15_STATUS = 0xf0,
+	YAHOO_SERVICE_YMSG15_BUDDY_LIST = 0xf1,
 };
 
@@ -242,13 +246,13 @@
 
 struct yahoo_search_state {
-	int   lsearch_type;
-	char  *lsearch_text;
-	int   lsearch_gender;
-	int   lsearch_agerange;
-	int   lsearch_photo;
-	int   lsearch_yahoo_only;
-	int   lsearch_nstart;
-	int   lsearch_nfound;
-	int   lsearch_ntotal;
+	int lsearch_type;
+	char *lsearch_text;
+	int lsearch_gender;
+	int lsearch_agerange;
+	int lsearch_photo;
+	int lsearch_yahoo_only;
+	int lsearch_nstart;
+	int lsearch_nfound;
+	int lsearch_ntotal;
 };
 
@@ -264,28 +268,28 @@
 	struct yahoo_search_state *ys;
 
-	int   fd;
+	int fd;
 	enum yahoo_connection_type type;
 	
-	unsigned char	*rxqueue;
-	int   rxlen;
-	int   read_tag;
+	unsigned char *rxqueue;
+	int rxlen;
+	int read_tag;
 
 	YList *txqueues;
-	int   write_tag;
+	int write_tag;
 };
 
 struct yahoo_server_settings {
 	char *pager_host;
-	int   pager_port;
+	int pager_port;
 	char *filetransfer_host;
-	int   filetransfer_port;
+	int filetransfer_port;
 	char *webcam_host;
-	int   webcam_port;
+	int webcam_port;
 	char *webcam_description;
 	char *local_host;
-	int   conn_type;
+	int conn_type;
 };
 
-static void * _yahoo_default_server_settings()
+static void *_yahoo_default_server_settings()
 {
 	struct yahoo_server_settings *yss = y_new0(struct yahoo_server_settings, 1);
@@ -304,52 +308,52 @@
 }
 
-static void * _yahoo_assign_server_settings(va_list ap)
+static void *_yahoo_assign_server_settings(va_list ap)
 {
 	struct yahoo_server_settings *yss = _yahoo_default_server_settings();
 	char *key;
 	char *svalue;
-	int   nvalue;
-
-	while(1) {
+	int nvalue;
+
+	while (1) {
 		key = va_arg(ap, char *);
-		if(key == NULL)
-			break;
-
-		if(!strcmp(key, "pager_host")) {
+		if (key == NULL)
+			break;
+
+		if (!strcmp(key, "pager_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->pager_host);
 			yss->pager_host = strdup(svalue);
-		} else if(!strcmp(key, "pager_port")) {
+		} else if (!strcmp(key, "pager_port")) {
 			nvalue = va_arg(ap, int);
 			yss->pager_port = nvalue;
-		} else if(!strcmp(key, "filetransfer_host")) {
+		} else if (!strcmp(key, "filetransfer_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->filetransfer_host);
 			yss->filetransfer_host = strdup(svalue);
-		} else if(!strcmp(key, "filetransfer_port")) {
+		} else if (!strcmp(key, "filetransfer_port")) {
 			nvalue = va_arg(ap, int);
 			yss->filetransfer_port = nvalue;
-		} else if(!strcmp(key, "webcam_host")) {
+		} else if (!strcmp(key, "webcam_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->webcam_host);
 			yss->webcam_host = strdup(svalue);
-		} else if(!strcmp(key, "webcam_port")) {
+		} else if (!strcmp(key, "webcam_port")) {
 			nvalue = va_arg(ap, int);
 			yss->webcam_port = nvalue;
-		} else if(!strcmp(key, "webcam_description")) {
+		} else if (!strcmp(key, "webcam_description")) {
 			svalue = va_arg(ap, char *);
 			free(yss->webcam_description);
 			yss->webcam_description = strdup(svalue);
-		} else if(!strcmp(key, "local_host")) {
+		} else if (!strcmp(key, "local_host")) {
 			svalue = va_arg(ap, char *);
 			free(yss->local_host);
 			yss->local_host = strdup(svalue);
-		} else if(!strcmp(key, "conn_type")) {
+		} else if (!strcmp(key, "conn_type")) {
 			nvalue = va_arg(ap, int);
 			yss->conn_type = nvalue;
 		} else {
 			WARNING(("Unknown key passed to yahoo_init, "
-				"perhaps you didn't terminate the list "
-				"with NULL"));
+					"perhaps you didn't terminate the list "
+					"with NULL"));
 		}
 	}
@@ -360,5 +364,5 @@
 static void yahoo_free_server_settings(struct yahoo_server_settings *yss)
 {
-	if(!yss)
+	if (!yss)
 		return;
 
@@ -372,7 +376,7 @@
 }
 
-static YList *conns=NULL;
-static YList *inputs=NULL;
-static int last_id=0;
+static YList *conns = NULL;
+static YList *inputs = NULL;
+static int last_id = 0;
 
 static void add_to_list(struct yahoo_data *yd)
@@ -380,10 +384,10 @@
 	conns = y_list_prepend(conns, yd);
 }
-static struct yahoo_data * find_conn_by_id(int id)
+static struct yahoo_data *find_conn_by_id(int id)
 {
 	YList *l;
-	for(l = conns; l; l = y_list_next(l)) {
+	for (l = conns; l; l = y_list_next(l)) {
 		struct yahoo_data *yd = l->data;
-		if(yd->client_id == id)
+		if (yd->client_id == id)
 			return yd;
 	}
@@ -396,5 +400,5 @@
 
 /* call repeatedly to get the next one */
-static struct yahoo_input_data * find_input_by_id(int id)
+static struct yahoo_input_data *find_input_by_id(int id)
 {
 	YList *l;
@@ -407,11 +411,11 @@
 }
 
-static struct yahoo_input_data * find_input_by_id_and_webcam_user(int id, const char * who)
+static struct yahoo_input_data *find_input_by_id_and_webcam_user(int id, const char *who)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_webcam_user"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->type == YAHOO_CONNECTION_WEBCAM && yid->yd->client_id == id 
+		if (yid->type == YAHOO_CONNECTION_WEBCAM && yid->yd->client_id == id 
 				&& yid->wcm && 
 				((who && yid->wcm->user && !strcmp(who, yid->wcm->user)) ||
@@ -422,11 +426,11 @@
 }
 
-static struct yahoo_input_data * find_input_by_id_and_type(int id, enum yahoo_connection_type type)
+static struct yahoo_input_data *find_input_by_id_and_type(int id, enum yahoo_connection_type type)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_type"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->type == type && yid->yd->client_id == id)
+		if (yid->type == type && yid->yd->client_id == id)
 			return yid;
 	}
@@ -434,11 +438,11 @@
 }
 
-static struct yahoo_input_data * find_input_by_id_and_fd(int id, int fd)
+static struct yahoo_input_data *find_input_by_id_and_fd(int id, int fd)
 {
 	YList *l;
 	LOG(("find_input_by_id_and_fd"));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->fd == fd && yid->yd->client_id == id)
+		if (yid->fd == fd && yid->yd->client_id == id)
 			return yid;
 	}
@@ -448,10 +452,10 @@
 static int count_inputs_with_id(int id)
 {
-	int c=0;
+	int c = 0;
 	YList *l;
 	LOG(("counting %d", id));
-	for(l = inputs; l; l = y_list_next(l)) {
+	for (l = inputs; l; l = y_list_next(l)) {
 		struct yahoo_input_data *yid = l->data;
-		if(yid->yd->client_id == id)
+		if (yid->yd->client_id == id)
 			c++;
 	}
@@ -464,12 +468,11 @@
 
 /* Free a buddy list */
-static void yahoo_free_buddies(YList * list)
+static void yahoo_free_buddies(YList *list)
 {
 	YList *l;
 
-	for(l = list; l; l = l->next)
-	{
+	for (l = list; l; l = l->next) {
 		struct yahoo_buddy *bud = l->data;
-		if(!bud)
+		if (!bud)
 			continue;
 
@@ -477,5 +480,5 @@
 		FREE(bud->id);
 		FREE(bud->real_name);
-		if(bud->yab_entry) {
+		if (bud->yab_entry) {
 			FREE(bud->yab_entry->fname);
 			FREE(bud->yab_entry->lname);
@@ -496,5 +499,5 @@
 
 /* Free an identities list */
-static void yahoo_free_identities(YList * list)
+static void yahoo_free_identities(YList *list)
 {
 	while (list) {
@@ -690,28 +693,27 @@
 }
 
-
 static void yahoo_packet_dump(unsigned char *data, int len)
 {
-	if(yahoo_get_log_level() >= YAHOO_LOG_DEBUG) {
+	if (yahoo_get_log_level() >= YAHOO_LOG_DEBUG) {
 		int i;
 		for (i = 0; i < len; i++) {
 			if ((i % 8 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)(" ");
+				YAHOO_CALLBACK(ext_yahoo_log) (" ");
 			if ((i % 16 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)("\n");
-			YAHOO_CALLBACK(ext_yahoo_log)("%02x ", data[i]);
-		}
-		YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) ("\n");
+			YAHOO_CALLBACK(ext_yahoo_log) ("%02x ", data[i]);
+		}
+		YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 		for (i = 0; i < len; i++) {
 			if ((i % 8 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)(" ");
+				YAHOO_CALLBACK(ext_yahoo_log) (" ");
 			if ((i % 16 == 0) && i)
-				YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 			if (isprint(data[i]))
-				YAHOO_CALLBACK(ext_yahoo_log)(" %c ", data[i]);
+				YAHOO_CALLBACK(ext_yahoo_log) (" %c ", data[i]);
 			else
-				YAHOO_CALLBACK(ext_yahoo_log)(" . ");
-		}
-		YAHOO_CALLBACK(ext_yahoo_log)("\n");
+				YAHOO_CALLBACK(ext_yahoo_log) (" . ");
+		}
+		YAHOO_CALLBACK(ext_yahoo_log) ("\n");
 	}
 }
@@ -723,5 +725,6 @@
 }
 
-static void yahoo_add_to_send_queue(struct yahoo_input_data *yid, void *data, int length)
+static void yahoo_add_to_send_queue(struct yahoo_input_data *yid, void *data,
+	int length)
 {
 	struct data_queue *tx = y_new0(struct data_queue, 1);
@@ -732,13 +735,15 @@
 	yid->txqueues = y_list_append(yid->txqueues, tx);
 
-	if(!yid->write_tag)
-		yid->write_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, yid->fd, YAHOO_INPUT_WRITE, yid);
-}
-
-static void yahoo_send_packet(struct yahoo_input_data *yid, struct yahoo_packet *pkt, int extra_pad)
+	if (!yid->write_tag)
+		yid->write_tag =
+			YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->
+			client_id, yid->fd, YAHOO_INPUT_WRITE, yid);
+}
+
+static void yahoo_send_packet(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt, int extra_pad)
 {
 	int pktlen = yahoo_packet_length(pkt);
 	int len = YAHOO_PACKET_HDRLEN + pktlen;
-
 	unsigned char *data;
 	int pos = 0;
@@ -749,17 +754,18 @@
 	data = y_new0(unsigned char, len + 1);
 
-	memcpy(data + pos, "YMSG", 4); pos += 4;
-	pos += yahoo_put16(data + pos, YAHOO_PROTO_VER);
-	pos += yahoo_put16(data + pos, 0x0000);
-	pos += yahoo_put16(data + pos, pktlen + extra_pad);
-	pos += yahoo_put16(data + pos, pkt->service);
-	pos += yahoo_put32(data + pos, pkt->status);
-	pos += yahoo_put32(data + pos, pkt->id);
+	memcpy(data + pos, "YMSG", 4);
+	pos += 4;
+	pos += yahoo_put16(data + pos, YAHOO_PROTO_VER);	/* version [latest 12 0x000c] */
+	pos += yahoo_put16(data + pos, 0x0000);	/* HIWORD pkt length??? */
+	pos += yahoo_put16(data + pos, pktlen + extra_pad);	/* LOWORD pkt length? */
+	pos += yahoo_put16(data + pos, pkt->service);	/* service */
+	pos += yahoo_put32(data + pos, pkt->status);	/* status [4bytes] */
+	pos += yahoo_put32(data + pos, pkt->id);	/* session [4bytes] */
 
 	yahoo_packet_write(pkt, data + pos);
 
 	yahoo_packet_dump(data, len);
-	
-	if( yid->type == YAHOO_CONNECTION_FT )
+
+	if (yid->type == YAHOO_CONNECTION_FT)
 		yahoo_send_data(yid->fd, data, len);
 	else
@@ -794,8 +800,8 @@
 	do {
 		ret = write(fd, data, len);
-	} while(ret == -1 && errno==EINTR);
-	e=errno;
-
-	if (ret == -1)  {
+	} while (ret == -1 && errno == EINTR);
+	e = errno;
+
+	if (ret == -1) {
 		LOG(("wrote data: ERR %s", strerror(errno)));
 	} else {
@@ -803,13 +809,12 @@
 	}
 
-	errno=e;
+	errno = e;
 	return ret;
 }
 
-void yahoo_close(int id) 
+void yahoo_close(int id)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
-	
-	if(!yd)
+	if (!yd)
 		return;
 
@@ -817,29 +822,31 @@
 
 	yahoo_free_data(yd);
-	if(id == last_id)
+	if (id == last_id)
 		last_id--;
 }
 
-static void yahoo_input_close(struct yahoo_input_data *yid) 
+static void yahoo_input_close(struct yahoo_input_data *yid)
 {
 	inputs = y_list_remove(inputs, yid);
 
-	LOG(("yahoo_input_close(read)")); 
-	YAHOO_CALLBACK(ext_yahoo_remove_handler)(yid->yd->client_id, yid->read_tag);
-	LOG(("yahoo_input_close(write)")); 
-	YAHOO_CALLBACK(ext_yahoo_remove_handler)(yid->yd->client_id, yid->write_tag);
+	LOG(("yahoo_input_close(read)"));
+	YAHOO_CALLBACK(ext_yahoo_remove_handler) (yid->yd->client_id,
+		yid->read_tag);
+	LOG(("yahoo_input_close(write)"));
+	YAHOO_CALLBACK(ext_yahoo_remove_handler) (yid->yd->client_id,
+		yid->write_tag);
 	yid->read_tag = yid->write_tag = 0;
-	if(yid->fd)
+	if (yid->fd)
 		close(yid->fd);
 	yid->fd = 0;
 	FREE(yid->rxqueue);
-	if(count_inputs_with_id(yid->yd->client_id) == 0) {
+	if (count_inputs_with_id(yid->yd->client_id) == 0) {
 		LOG(("closing %d", yid->yd->client_id));
 		yahoo_close(yid->yd->client_id);
 	}
 	yahoo_free_webcam(yid->wcm);
-	if(yid->wcd)
+	if (yid->wcd)
 		FREE(yid->wcd);
-	if(yid->ys) {
+	if (yid->ys) {
 		FREE(yid->ys->lsearch_text);
 		FREE(yid->ys);
@@ -848,5 +855,6 @@
 }
 
-static int is_same_bud(const void * a, const void * b) {
+static int is_same_bud(const void *a, const void *b)
+{
 	const struct yahoo_buddy *subject = a;
 	const struct yahoo_buddy *object = b;
@@ -855,17 +863,17 @@
 }
 
-static char * getcookie(char *rawcookie)
-{
-	char * cookie=NULL;
-	char * tmpcookie; 
-	char * cookieend;
-
-	if (strlen(rawcookie) < 2) 
+static char *getcookie(char *rawcookie)
+{
+	char *cookie = NULL;
+	char *tmpcookie;
+	char *cookieend;
+
+	if (strlen(rawcookie) < 2)
 		return NULL;
 
-	tmpcookie = strdup(rawcookie+2);
+	tmpcookie = strdup(rawcookie + 2);
 	cookieend = strchr(tmpcookie, ';');
 
-	if(cookieend)
+	if (cookieend)
 		*cookieend = '\0';
 
@@ -877,5 +885,5 @@
 }
 
-static char * getlcookie(char *cookie)
+static char *getlcookie(char *cookie)
 {
 	char *tmp;
@@ -884,9 +892,9 @@
 
 	tmpend = strstr(cookie, "n=");
-	if(tmpend) {
-		tmp = strdup(tmpend+2);
+	if (tmpend) {
+		tmp = strdup(tmpend + 2);
 		tmpend = strchr(tmp, '&');
-		if(tmpend)
-			*tmpend='\0';
+		if (tmpend)
+			*tmpend = '\0';
 		login_cookie = strdup(tmp);
 		FREE(tmp);
@@ -896,5 +904,6 @@
 }
 
-static void yahoo_process_notify(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_notify(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -927,13 +936,15 @@
 	if (!msg)
 		return;
-	
-	if (!strncasecmp(msg, "TYPING", strlen("TYPING"))) 
-		YAHOO_CALLBACK(ext_yahoo_typing_notify)(yd->client_id, to, from, stat);
-	else if (!strncasecmp(msg, "GAME", strlen("GAME"))) 
-		YAHOO_CALLBACK(ext_yahoo_game_notify)(yd->client_id, to, from, stat);
-	else if (!strncasecmp(msg, "WEBCAMINVITE", strlen("WEBCAMINVITE"))) 
-	{
+
+	if (!strncasecmp(msg, "TYPING", strlen("TYPING")))
+		YAHOO_CALLBACK(ext_yahoo_typing_notify) (yd->client_id, to,
+			from, stat);
+	else if (!strncasecmp(msg, "GAME", strlen("GAME")))
+		YAHOO_CALLBACK(ext_yahoo_game_notify) (yd->client_id, to, from,
+			stat);
+	else if (!strncasecmp(msg, "WEBCAMINVITE", strlen("WEBCAMINVITE"))) {
 		if (!strcmp(ind, " ")) {
-			YAHOO_CALLBACK(ext_yahoo_webcam_invite)(yd->client_id, to, from);
+			YAHOO_CALLBACK(ext_yahoo_webcam_invite) (yd->client_id,
+				to, from);
 		} else {
 			accept = atoi(ind);
@@ -941,8 +952,8 @@
 			if (accept < 0)
 				accept = 0;
-			YAHOO_CALLBACK(ext_yahoo_webcam_invite_reply)(yd->client_id, to, from, accept);
-		}
-	}
-	else
+			YAHOO_CALLBACK(ext_yahoo_webcam_invite_reply) (yd->
+				client_id, to, from, accept);
+		}
+	} else
 		LOG(("Got unknown notification: %s", msg));
 }
@@ -951,14 +962,14 @@
 {
 	struct yahoo_data *yd = yid->yd;
-	char *from=NULL;
-	char *to=NULL;
-	char *msg=NULL;
-	char *url=NULL;
-	long expires=0;
-
-	char *service=NULL;
-
-	char *filename=NULL;
-	unsigned long filesize=0L;
+	char *from = NULL;
+	char *to = NULL;
+	char *msg = NULL;
+	char *url = NULL;
+	long expires = 0;
+
+	char *service = NULL;
+
+	char *filename = NULL;
+	unsigned long filesize = 0L;
 
 	YList *l;
@@ -985,6 +996,6 @@
 	}
 
-	if(pkt->service == YAHOO_SERVICE_P2PFILEXFER) {
-		if(strcmp("FILEXFER", service) != 0) {
+	if (pkt->service == YAHOO_SERVICE_P2PFILEXFER) {
+		if (strcmp("FILEXFER", service) != 0) {
 			WARNING(("unhandled service 0x%02x", pkt->service));
 			yahoo_dump_unhandled(pkt);
@@ -993,12 +1004,12 @@
 	}
 
-	if(msg) {
+	if (msg) {
 		char *tmp;
 		tmp = strchr(msg, '\006');
-		if(tmp)
+		if (tmp)
 			*tmp = '\0';
 	}
-	if(url && from)
-		YAHOO_CALLBACK(ext_yahoo_got_file)(yd->client_id, to, from, url, expires, msg, filename, filesize);
+	if (url && from)
+		YAHOO_CALLBACK(ext_yahoo_got_file) (yd->client_id, to, from, url, expires, msg, filename, filesize);
 
 }
@@ -1012,23 +1023,23 @@
 	char *room = NULL;
 	char *id = NULL;
-	int  utf8 = 0;
+	int utf8 = 0;
 	YList *members = NULL;
 	YList *l;
-	
+
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 50)
 			host = pair->value;
-		
-		if (pair->key == 52) {		/* invite */
+
+		if (pair->key == 52) {	/* invite */
 			members = y_list_append(members, strdup(pair->value));
 		}
-		if (pair->key == 53)		/* logon */
+		if (pair->key == 53)	/* logon */
 			who = pair->value;
-		if (pair->key == 54)		/* decline */
+		if (pair->key == 54)	/* decline */
 			who = pair->value;
-		if (pair->key == 55)		/* unavailable (status == 2) */
+		if (pair->key == 55)	/* unavailable (status == 2) */
 			who = pair->value;
-		if (pair->key == 56)		/* logoff */
+		if (pair->key == 56)	/* logoff */
 			who = pair->value;
 
@@ -1036,17 +1047,16 @@
 			room = pair->value;
 
-		if (pair->key == 58)		/* join message */
+		if (pair->key == 58)	/* join message */
 			msg = pair->value;
-		if (pair->key == 14)		/* decline/conf message */
+		if (pair->key == 14)	/* decline/conf message */
 			msg = pair->value;
 
-		if (pair->key == 13)
-			;
-		if (pair->key == 16)		/* error */
+		if (pair->key == 13) ;
+		if (pair->key == 16)	/* error */
 			msg = pair->value;
 
-		if (pair->key == 1)		/* my id */
+		if (pair->key == 1)	/* my id */
 			id = pair->value;
-		if (pair->key == 3)		/* message sender */
+		if (pair->key == 3)	/* message sender */
 			who = pair->value;
 
@@ -1055,53 +1065,59 @@
 	}
 
-	if(!room)
-		return;
-
-	if(host) {
-		for(l = members; l; l = l->next) {
-			char * w = l->data;
-			if(!strcmp(w, host))
+	if (!room)
+		return;
+
+	if (host) {
+		for (l = members; l; l = l->next) {
+			char *w = l->data;
+			if (!strcmp(w, host))
 				break;
 		}
-		if(!l)
+		if (!l)
 			members = y_list_append(members, strdup(host));
 	}
 	/* invite, decline, join, left, message -> status == 1 */
 
-	switch(pkt->service) {
+	switch (pkt->service) {
 	case YAHOO_SERVICE_CONFINVITE:
-		if(pkt->status == 2)
-			;
-		else if(members)
-			YAHOO_CALLBACK(ext_yahoo_got_conf_invite)(yd->client_id, id, host, room, msg, members);
-		else if(msg)
-			YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, msg, 0, E_CONFNOTAVAIL);
+		if (pkt->status == 2) ;
+		else if (members)
+			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->
+				client_id, id, host, room, msg, members);
+		else if (msg)
+			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, msg, 0,
+				E_CONFNOTAVAIL);
 		break;
 	case YAHOO_SERVICE_CONFADDINVITE:
-		if(pkt->status == 2)
+		if (pkt->status == 2)
 			;
 		else
-			YAHOO_CALLBACK(ext_yahoo_got_conf_invite)(yd->client_id, id, host, room, msg, members);
+			YAHOO_CALLBACK(ext_yahoo_got_conf_invite) (yd->client_id, id, host, room, msg, members);
 		break;
 	case YAHOO_SERVICE_CONFDECLINE:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userdecline)(yd->client_id, id, who, room, msg);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userdecline) (yd->
+				client_id, id, who, room, msg);
 		break;
 	case YAHOO_SERVICE_CONFLOGON:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userjoin)(yd->client_id, id, who, room);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userjoin) (yd->client_id,
+				id, who, room);
 		break;
 	case YAHOO_SERVICE_CONFLOGOFF:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_userleave)(yd->client_id, id, who, room);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_userleave) (yd->client_id,
+				id, who, room);
 		break;
 	case YAHOO_SERVICE_CONFMSG:
-		if(who)
-			YAHOO_CALLBACK(ext_yahoo_conf_message)(yd->client_id, id, who, room, msg, utf8);
+		if (who)
+			YAHOO_CALLBACK(ext_yahoo_conf_message) (yd->client_id,
+				id, who, room, msg, utf8);
 		break;
 	}
 }
 
-static void yahoo_process_chat(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_chat(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *msg = NULL;
@@ -1112,9 +1128,9 @@
 	YList *members = NULL;
 	struct yahoo_chat_member *currentmember = NULL;
-	int  msgtype = 1;
-	int  utf8 = 0;
-	int  firstjoin = 0;
-	int  membercount = 0;
-	int  chaterr=0;
+	int msgtype = 1;
+	int utf8 = 0;
+	int firstjoin = 0;
+	int membercount = 0;
+	int chaterr = 0;
 	YList *l;
 	
@@ -1148,5 +1164,6 @@
 
 			if (pkt->service == YAHOO_SERVICE_CHATJOIN) {
-				currentmember = y_new0(struct yahoo_chat_member, 1);
+				currentmember =
+					y_new0(struct yahoo_chat_member, 1);
 				currentmember->id = strdup(pair->value);
 				members = y_list_append(members, currentmember);
@@ -1178,5 +1195,4 @@
 		}
 
-
 		if (pair->key == 130) {
 			/* first join */
@@ -1196,17 +1212,19 @@
 			/* message error not sure what all the pair values mean */
 			/* but -1 means no session in room */
-			chaterr= atoi(pair->value);
-		}
-	}
-
-	if(!room) {
-		if (pkt->service == YAHOO_SERVICE_CHATLOGOUT) { /* yahoo originated chat logout */
-			YAHOO_CALLBACK(ext_yahoo_chat_yahoologout)(yid->yd->client_id, id);
-			return ;
-		}
-		if (pkt->service == YAHOO_SERVICE_COMMENT && chaterr)  {
-			YAHOO_CALLBACK(ext_yahoo_chat_yahooerror)(yid->yd->client_id, id);
+			chaterr = atoi(pair->value);
+		}
+	}
+
+	if (!room) {
+		if (pkt->service == YAHOO_SERVICE_CHATLOGOUT) {	/* yahoo originated chat logout */
+			YAHOO_CALLBACK(ext_yahoo_chat_yahoologout) (yid->yd->
+				client_id, id);
 			return;
 		}
+		if (pkt->service == YAHOO_SERVICE_COMMENT && chaterr) {
+			YAHOO_CALLBACK(ext_yahoo_chat_yahooerror) (yid->yd->
+				client_id, id);
+			return;
+		}
 
 		WARNING(("We didn't get a room name, ignoring packet"));
@@ -1214,33 +1232,37 @@
 	}
 
-	switch(pkt->service) {
+	switch (pkt->service) {
 	case YAHOO_SERVICE_CHATJOIN:
-		if(y_list_length(members) != membercount) {
+		if (y_list_length(members) != membercount) {
 			WARNING(("Count of members doesn't match No. of members we got"));
 		}
-		if(firstjoin && members) {
-			YAHOO_CALLBACK(ext_yahoo_chat_join)(yid->yd->client_id, id, room, topic, members, yid->fd);
-		} else if(who) {
-			if(y_list_length(members) != 1) {
+		if (firstjoin && members) {
+			YAHOO_CALLBACK(ext_yahoo_chat_join) (yid->yd->client_id,
+				id, room, topic, members, yid->fd);
+		} else if (who) {
+			if (y_list_length(members) != 1) {
 				WARNING(("Got more than 1 member on a normal join"));
 			}
 			/* this should only ever have one, but just in case */
-			while(members) {
+			while (members) {
 				YList *n = members->next;
 				currentmember = members->data;
-				YAHOO_CALLBACK(ext_yahoo_chat_userjoin)(yid->yd->client_id, id, room, currentmember);
+				YAHOO_CALLBACK(ext_yahoo_chat_userjoin) (yid->
+					yd->client_id, id, room, currentmember);
 				y_list_free_1(members);
-				members=n;
+				members = n;
 			}
 		}
 		break;
 	case YAHOO_SERVICE_CHATEXIT:
-		if(who) {
-			YAHOO_CALLBACK(ext_yahoo_chat_userleave)(yid->yd->client_id, id, room, who);
+		if (who) {
+			YAHOO_CALLBACK(ext_yahoo_chat_userleave) (yid->yd->
+				client_id, id, room, who);
 		}
 		break;
 	case YAHOO_SERVICE_COMMENT:
-		if(who) {
-			YAHOO_CALLBACK(ext_yahoo_chat_message)(yid->yd->client_id, id, who, room, msg, msgtype, utf8);
+		if (who) {
+			YAHOO_CALLBACK(ext_yahoo_chat_message) (yid->yd->
+				client_id, id, who, room, msg, msgtype, utf8);
 		}
 		break;
@@ -1248,28 +1270,27 @@
 }
 
-static void yahoo_process_message(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_message(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
 	YList *l;
-	YList * messages = NULL;
+	YList *messages = NULL;
 
 	struct m {
-		int  i_31;
-		int  i_32;
+		int i_31;
+		int i_32;
 		char *to;
 		char *from;
 		long tm;
 		char *msg;
-		int  utf8;
+		int utf8;
 	} *message = y_new0(struct m, 1);
 
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
-		if (pair->key == 1 || pair->key == 4)
-		{
-			if(!message->from)
+		if (pair->key == 1 || pair->key == 4) {
+			if (!message->from)
 				message->from = pair->value;
-		}
-		else if (pair->key == 5)
+		} else if (pair->key == 5)
 			message->to = pair->value;
 		else if (pair->key == 15)
@@ -1281,27 +1302,25 @@
 			message->msg = pair->value;
 		else if (pair->key == 31) {
-			if(message->i_31) {
+			if (message->i_31) {
 				messages = y_list_append(messages, message);
 				message = y_new0(struct m, 1);
 			}
 			message->i_31 = atoi(pair->value);
-		}
-		else if (pair->key == 32)
+		} else if (pair->key == 32)
 			message->i_32 = atoi(pair->value);
 		else
-			LOG(("yahoo_process_message: status: %d, key: %d, value: %s",
-					pkt->status, pair->key, pair->value));
+			LOG(("yahoo_process_message: status: %d, key: %d, value: %s", pkt->status, pair->key, pair->value));
 	}
 
 	messages = y_list_append(messages, message);
 
-	for (l = messages; l; l=l->next) {
+	for (l = messages; l; l = l->next) {
 		message = l->data;
 		if (pkt->service == YAHOO_SERVICE_SYSMESSAGE) {
-			YAHOO_CALLBACK(ext_yahoo_system_message)(yd->client_id, message->msg);
+			YAHOO_CALLBACK(ext_yahoo_system_message) (yd->client_id, message->msg);
 		} else if (pkt->status <= 2 || pkt->status == 5) {
-			YAHOO_CALLBACK(ext_yahoo_got_im)(yd->client_id, message->to, message->from, message->msg, message->tm, pkt->status, message->utf8);
+			YAHOO_CALLBACK(ext_yahoo_got_im) (yd->client_id, message->to, message->from, message->msg, message->tm, pkt->status, message->utf8);
 		} else if (pkt->status == 0xffffffff) {
-			YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, message->msg, 0, E_SYSTEM);
+			YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, message->msg, 0, E_SYSTEM);
 		}
 		free(message);
@@ -1327,8 +1346,10 @@
 	}
 
-	/* Status updates may be spread accross multiple packets and not
-	   even on buddy boundaries, so keeping some state is important.
-	   So, continue where we left off, and only add a user entry to
-	   the list once it's complete (301-315 End buddy). */
+	/* 
+	 * Status updates may be spread accross multiple packets and not 
+	 * even on buddy boundaries, so keeping some state is important. 
+	 * So, continue where we left off, and only add a user entry to 
+	 * the list once it's complete (301-315 End buddy).
+	 */
 	u = yd->half_user;
 
@@ -1594,15 +1615,18 @@
 }
 
-static void yahoo_process_verify(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_verify(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
 
-	if(pkt->status != 0x01) {
+	if (pkt->status != 0x01) {
 		DEBUG_MSG(("expected status: 0x01, got: %d", pkt->status));
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, YAHOO_LOGIN_LOCK, "");
-		return;
-	}
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YAHOO_STATUS_AVAILABLE, yd->session_id);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			YAHOO_LOGIN_LOCK, "");
+		return;
+	}
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 1, yd->user);
@@ -1613,5 +1637,6 @@
 }
 
-static void yahoo_process_picture_checksum( struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_picture_checksum(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1621,28 +1646,28 @@
 	YList *l;
 
-	for(l = pkt->hash; l; l = l->next)
-	{
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
-			case 1:
-			case 4:
-				from = pair->value;
-			case 5:
-				to = pair->value;
-				break;
-			case 212:
-				break;
-			case 192:
-				checksum = atoi( pair->value );
-				break;
-		}
-	}
-
-	YAHOO_CALLBACK(ext_yahoo_got_buddyicon_checksum)(yd->client_id,to,from,checksum);
-}
-
-static void yahoo_process_picture(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		switch (pair->key) {
+		case 1:
+		case 4:
+			from = pair->value;
+		case 5:
+			to = pair->value;
+			break;
+		case 212:
+			break;
+		case 192:
+			checksum = atoi(pair->value);
+			break;
+		}
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_got_buddyicon_checksum) (yd->client_id, to,
+		from, checksum);
+}
+
+static void yahoo_process_picture(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
